Package org.apache.sis.metadata.iso.constraint

## Class DefaultConstraints

- Object
- - AbstractMetadata
  - - ModifiableMetadata
    - - ISOMetadata
      - - DefaultConstraints

- All Implemented Interfaces:
    `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `Constraints`
  Direct Known Subclasses:
    `DefaultLegalConstraints`, `DefaultSecurityConstraints`

      public class DefaultConstraints
      extends ISOMetadata
      implements Constraints

  Restrictions on the access and use of a resource or metadata.

  Limitations:

  - Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
  - Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
  Since:
    0.3
  See Also:
    Serialized Form

  Defined in the `sis-metadata` module

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class ModifiableMetadata

      `ModifiableMetadata​.State`

  - ### Field Summary

    - ### Fields inherited from class ISOMetadata

      `identifiers`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DefaultConstraints()` | Constructs an initially empty constraints.
    `DefaultConstraints​(CharSequence useLimitation)` | Constructs a new constraints with the given use limitation.
    `DefaultConstraints​(Constraints object)` | Constructs a new instance initialized with the values from the specified metadata object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static DefaultConstraints` | `castOrCopy​(Constraints object)` | Returns a SIS metadata implementation with the values of the given arbitrary implementation.
    `Scope` | `getConstraintApplicationScope()` | Returns the spatial and / or temporal extents and or levels of the application of the constraints restrictions.
    `Collection<BrowseGraphic>` | `getGraphics()` | Returns the graphics / symbols indicating the constraint.
    `Collection<Citation>` | `getReferences()` | Returns citations for the limitation of constraint.
    `DefaultReleasability` | `getReleasability()` | Returns information concerning the parties to whom the resource can or cannot be released.
    `Collection<DefaultResponsibility>` | `getResponsibleParties()` | Returns the parties responsible for the resource constraints.
    `Collection<InternationalString>` | `getUseLimitations()` | Returns the limitation affecting the fitness for use of the resource.
    `void` | `setConstraintApplicationScope​(Scope newValue)` | Sets the spatial and / or temporal extents and or levels of the application of the constraints restrictions.
    `void` | `setGraphics​(Collection<? extends BrowseGraphic> newValues)` | Sets the new graphics / symbols indicating the constraint.
    `void` | `setReferences​(Collection<? extends Citation> newValues)` | Sets the citations for the limitation of constraint.
    `void` | `setReleasability​(DefaultReleasability newValue)` | Sets the information concerning the parties to whom the resource.
    `void` | `setResponsibleParties​(Collection<? extends DefaultResponsibility> newValues)` | Sets the parties responsible for the resource constraints.
    `void` | `setUseLimitations​(Collection<? extends InternationalString> newValues)` | Sets the limitation affecting the fitness for use of the resource.

    - ### Methods inherited from class ISOMetadata

      `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

    - ### Methods inherited from class ModifiableMetadata

      `checkWritePermission, checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, freeze, isModifiable, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, unmodifiable, writeCollection, writeList, writeMap, writeSet`

    - ### Methods inherited from class AbstractMetadata

      `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultConstraints

          public DefaultConstraints()

      Constructs an initially empty constraints.

    - #### DefaultConstraints

          public DefaultConstraints​(CharSequence useLimitation)

      Constructs a new constraints with the given use limitation.
      Parameters:
        `useLimitation` - the use limitation, or `null` if none.

    - #### DefaultConstraints

          public DefaultConstraints​(Constraints object)

      Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the metadata to copy values from, or `null` if none.
      See Also:
        `castOrCopy(Constraints)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultConstraints castOrCopy​(Constraints object)

      Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
      - If the given object is `null`, then this method returns `null`.
      - Otherwise if the given object is an instance of `LegalConstraints` or `SecurityConstraints`, then this method delegates to the `castOrCopy(…)` method of the corresponding SIS subclass. Note that if the given object implements more than one of the above-cited interfaces, then the `castOrCopy(…)` method to be used is unspecified.
      - Otherwise if the given object is already an instance of `DefaultConstraints`, then it is returned unchanged.
      - Otherwise a new `DefaultConstraints` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getUseLimitations

          public Collection<InternationalString> getUseLimitations()

      Returns the limitation affecting the fitness for use of the resource. Example: "not to be used for navigation".
      Specified by:
        `getUseLimitations` in interface `Constraints`
      Returns:
        limitation affecting the fitness for use of the resource.

    - #### setUseLimitations

          public void setUseLimitations​(Collection<? extends InternationalString> newValues)

      Sets the limitation affecting the fitness for use of the resource. Example: "not to be used for navigation".
      Parameters:
        `newValues` - the new use limitations.

    - #### getConstraintApplicationScope

          @UML(identifier="constraintApplicationScope",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public Scope getConstraintApplicationScope()

      Returns the spatial and / or temporal extents and or levels of the application of the constraints restrictions.
      Returns:
        spatial and / or temporal extents.
      Since:
        0.5

    - #### setConstraintApplicationScope

          public void setConstraintApplicationScope​(Scope newValue)

      Sets the spatial and / or temporal extents and or levels of the application of the constraints restrictions.
      Parameters:
        `newValue` - the new spatial and / or temporal extents.
      Since:
        0.5

    - #### getGraphics

          @UML(identifier="graphic",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public Collection<BrowseGraphic> getGraphics()

      Returns the graphics / symbols indicating the constraint.
      Returns:
        the graphics / symbols indicating the constraint.
      Since:
        0.5

    - #### setGraphics

          public void setGraphics​(Collection<? extends BrowseGraphic> newValues)

      Sets the new graphics / symbols indicating the constraint.
      Parameters:
        `newValues` - the new graphics / symbols indicating the constraint.
      Since:
        0.5

    - #### getReferences

          @UML(identifier="reference",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public Collection<Citation> getReferences()

      Returns citations for the limitation of constraint. Example: "copyright statement, license agreement, etc."
      Returns:
        citations for the limitation of constraint.
      Since:
        0.5

    - #### setReferences

          public void setReferences​(Collection<? extends Citation> newValues)

      Sets the citations for the limitation of constraint.
      Parameters:
        `newValues` - the new citation for the limitation of constraint.
      Since:
        0.5

    - #### getReleasability

          @UML(identifier="releasability",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public DefaultReleasability getReleasability()

      Returns information concerning the parties to whom the resource can or cannot be released.
      Upcoming API change — generalization
      The return type will be changed to the `Releasability` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
      Returns:
        information concerning the parties to whom the resource can or cannot be released, or `null` if none.
      Since:
        0.5

    - #### setReleasability

          public void setReleasability​(DefaultReleasability newValue)

      Sets the information concerning the parties to whom the resource.
      Upcoming API change — generalization
      The argument type will be changed to the `Releasability` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
      Parameters:
        `newValue` - the new information concerning the parties to whom the resource can or cannot be released.
      Since:
        0.5

    - #### getResponsibleParties

          @UML(identifier="responsibleParty",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public Collection<DefaultResponsibility> getResponsibleParties()

      Returns the parties responsible for the resource constraints.
      Upcoming API change — generalization
      The element type will be changed to the `Responsibility` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
      Returns:
        parties responsible for the resource constraints.
      Since:
        0.5

    - #### setResponsibleParties

          public void setResponsibleParties​(Collection<? extends DefaultResponsibility> newValues)

      Sets the parties responsible for the resource constraints.
      Upcoming API change — generalization
      The element type will be changed to the `Responsibility` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
      Parameters:
        `newValues` - the new parties responsible for the resource constraints.
      Since:
        0.5